package model.widgetManufacturing;
import java.util.*;
import urml.runtime.*;
/**
 * The capsule class for Workstation.
 * @generated
 */
public class _C_Workstation extends Capsule {
	/**
	 * Call this constructor when the capsule is a root
	 */
	public _C_Workstation() {
		this(null);
	}
	
	/**
	 * Call this constructor when the capsule is not a
	 * root
	 * @param parent_ the parent of the capsule
	 */
	public _C_Workstation(Capsule parent) {
		this.parent = parent;
		internalports = Arrays.asList();
		
		externalports = Arrays.asList(_p_WS2CSPort);
		capsules = Arrays.asList();
		connectors = Arrays.asList(
		);
	}
	MessagePort _p_WS2CSPort = new MessagePort("WS2CSPort", new _P_WorkstationProtocol());
	final TimerPort _tp_ProductionTimer = new TimerPort();
	private int _a_widgetProductionTime = 3000;
	/**
	 * A state with name: on
	 */
	private State _state_on = new State(
	
		// name
		"on",
		
		// entry code
		() -> {
		},
		
		// exit code
		() -> {
		});
	/**
	 * A state with name: standby
	 */
	private State _state_standby = new State(
	
		// name
		"standby",
		
		// entry code
		() -> {
			System.out.println(this.name + ": logging to WSLog with: " + "WS: standby");
		},
		
		// exit code
		() -> {
		});
	/**
	 * A state with name: producing
	 */
	private State _state_producing = new State(
	
		// name
		"producing",
		
		// entry code
		() -> {
			{java.time.Instant timeoutInstant = java.time.Instant.now().plusMillis(_a_widgetProductionTime);
			instants.put(_tp_ProductionTimer, timeoutInstant);}
			System.out.println(this.name + ": logging to WSLog with: " + "WS: producing");
		},
		
		// exit code
		() -> {
		});
	/**
	 * A state with name: shutDown
	 */
	private State _state_shutDown = new State(
	
		// name
		"shutDown",
		
		// entry code
		() -> {
			System.out.println(this.name + ": logging to WSLog with: " + "WS: shutDown");
		},
		
		// exit code
		() -> {
		});
	/**
	 * A transition with name: t1
	 */
	private Transition _tran_t1 = new Transition(
	
		// name
		"t1",
		
		// guard
		() -> {
			return true;
		},
		
		// action code
		params -> {
		},
		
		// triggers
		Arrays.asList(
		),
		
		// timer port
		null
	);
	/**
	 * A transition with name: begin
	 */
	private Transition _tran_begin = new Transition(
	
		// name
		"begin",
		
		// guard
		() -> {
			return true;
		},
		
		// action code
		params -> {
		},
		
		// triggers
		Arrays.asList(
			new TriggerIn(
				_p_WS2CSPort, _P_WorkstationProtocol._s_produceWidget
			)
		),
		
		// timer port
		null
	);
	/**
	 * A transition with name: finished
	 */
	private Transition _tran_finished = new Transition(
	
		// name
		"finished",
		
		// guard
		() -> {
			return true;
		},
		
		// action code
		params -> {
			passMessage(_p_WS2CSPort, new Message(
				_p_WS2CSPort, 
				_P_WorkstationProtocol._s_widgetProduced,
				Arrays.asList(
				)));
		},
		
		// triggers
		Arrays.asList(
		),
		
		// timer port
		_tp_ProductionTimer
	);
	/**
	 * A transition with name: stop
	 */
	private Transition _tran_stop = new Transition(
	
		// name
		"stop",
		
		// guard
		() -> {
			return true;
		},
		
		// action code
		params -> {
		},
		
		// triggers
		Arrays.asList(
			new TriggerIn(
				_p_WS2CSPort, _P_WorkstationProtocol._s_shutDown
			)
		),
		
		// timer port
		null
	);
	/**
	 * Find the possible next transitions for each state
	 * @return outgoing transition for the current state
	 */
	public List<? extends Transition> findPossibleTrans() {
		switch (currentState.name) {
			case "on":
				return Arrays.asList(_tran_stop);
			case "standby":
				return Arrays.asList(_tran_begin, _tran_stop);
			case "producing":
				return Arrays.asList(_tran_finished, _tran_stop);
			case "shutDown":
				return Arrays.asList();
			default:
				return new ArrayList<>();
		}
	}
	/**
	 * Initial transition chain
	 */
	public void startInit() {
		synchronized (lock) {
		}
	}
	/**
	 * Executes the transition t and returns whether the
	 * destination state of t is final.  
	 */
	public boolean transitionAndIfFinal(
			Transition t, List<? extends CommonObj> params) {
		switch (t.name) {
			case "begin":
				if (_state_standby != currentState)
					throw new CurrentStateIsNotSourceStateInTransitionException();
				synchronized (lock) {
					_state_standby.exit.run();
					_tran_begin.action.accept(params);
					_state_producing.entry.run();
					currentState = _state_producing;
					return false;
				}
			case "finished":
				if (_state_producing != currentState)
					throw new CurrentStateIsNotSourceStateInTransitionException();
				synchronized (lock) {
					_state_producing.exit.run();
					_tran_finished.action.accept(params);
					_state_standby.entry.run();
					currentState = _state_standby;
					return false;
				}
			case "stop":
				if (_state_on != currentState)
					throw new CurrentStateIsNotSourceStateInTransitionException();
				synchronized (lock) {
					_state_on.exit.run();
					_tran_stop.action.accept(params);
					_state_shutDown.entry.run();
					currentState = _state_shutDown;
					return true;
				}
			default:
				return false;
		}
	}
}
